Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.fileupload
Class MultipartStream

    java.lang.Object
      org.apache.commons.fileupload.MultipartStream

    public class MultipartStream

extends java.lang.Object

Low level API for processing file uploads.

This class can be used to process data streams conforming to MIME 'multipart' format as defined in RFC 1867. Arbitrarily large amounts of data in the stream can be processed under constant memory usage.

The format of the stream is defined in the following way:
`multipart-body := preamble 1*encapsulation close-delimiter epilogue
encapsulation := delimiter body CRLF
delimiter := "--" boundary CRLF
close-delimiter := "--" boudary "--"
preamble := <ignore>
epilogue := <ignore>
body := header-part CRLF body-part
header-part := 1*header CRLF
header := header-name ":" header-value
header-name := <printable ascii characters except ":">
header-value := <any ascii characters except CR & LF>
body-data := <arbitrary data>
`

Note that body-data can contain another mulipart entity. There is limited support for single pass processing of such nested streams. The nested stream is required to have a boundary token of the same length as the parent stream (see `setBoundary(byte[])`).

Here is an example of usage of this class.

        try {
            MultipartStream multipartStream = new MultipartStream(input,
                                                                  boundary);
            boolean nextPart = multipartStream.skipPreamble();
            OutputStream output;
            while(nextPart) {
                header = chunks.readHeader();
                // process headers
                // create some output stream
                multipartStream.readBodyPart(output);
                nextPart = multipartStream.readBoundary();
            }
        } catch(MultipartStream.MalformedStreamException e) {
              // the stream failed to follow required syntax
        } catch(IOException) {
              // a read or write error occurred
        }

Version:
  $Id: MultipartStream.java 607869 2008-01-01 16:42:17Z jochen $
Author:
  Rafal Krzewski, Martin Cooper, Sean C. Sullivan

Nested Class Summary
`static class` | `MultipartStream.IllegalBoundaryException` Thrown upon attempt of setting an invalid boundary token.
`class` | `MultipartStream.ItemInputStream` An `InputStream` for reading an items contents.
`static class` | `MultipartStream.MalformedStreamException` Thrown to indicate that the input stream fails to follow the required syntax.

Field Summary
`protected static byte[]` | `BOUNDARY_PREFIX` A byte sequence that precedes a boundary (`CRLF--`).
`static byte` | `CR` The Carriage Return ASCII character value.
`static byte` | `DASH` The dash (-) ASCII character value.
`protected static int` | `DEFAULT_BUFSIZE` The default length of the buffer used for processing a request.
`protected static byte[]` | `FIELD_SEPARATOR` A byte sequence that that follows a delimiter that will be followed by an encapsulation (`CRLF`).
`static int` | `HEADER_PART_SIZE_MAX` The maximum length of `header-part` that will be processed (10 kilobytes = 10240 bytes.).
`protected static byte[]` | `HEADER_SEPARATOR` A byte sequence that marks the end of `header-part` (`CRLFCRLF`).
`static byte` | `LF` The Line Feed ASCII character value.
`protected static byte[]` | `STREAM_TERMINATOR` A byte sequence that that follows a delimiter of the last encapsulation in the stream (`--`).

Constructor Summary
`MultipartStream()` Deprecated. Use `MultipartStream(InputStream, byte[], org.apache.commons.fileupload.MultipartStream.ProgressNotifier)`, or `MultipartStream(InputStream, byte[], int, org.apache.commons.fileupload.MultipartStream.ProgressNotifier)`
`MultipartStream(java.io.InputStream input, byte[] boundary)` Deprecated. Use `MultipartStream(InputStream, byte[], MultipartStream.ProgressNotifier)`.
`MultipartStream(java.io.InputStream input, byte[] boundary, int bufSize)` Deprecated. Use `MultipartStream(InputStream, byte[], int, org.apache.commons.fileupload.MultipartStream.ProgressNotifier)`.

Method Summary
`static boolean` | `arrayequals(byte[] a, byte[] b, int count)` Compares `count` first bytes in the arrays `a` and `b`.
`int` | `discardBodyData()` Reads `body-data` from the current `encapsulation` and discards it.
`protected int` | `findByte(byte value, int pos)` Searches for a byte of specified value in the `buffer`, starting at the specified `position`.
`protected int` | `findSeparator()` Searches for the `boundary` in the `buffer` region delimited by `head` and `tail`.
`java.lang.String` | `getHeaderEncoding()` Retrieves the character encoding used when reading the headers of an individual part.
`int` | `readBodyData(java.io.OutputStream output)` Reads `body-data` from the current `encapsulation` and writes its contents into the output `Stream`.
`boolean` | `readBoundary()` Skips a `boundary` token, and checks whether more `encapsulations` are contained in the stream.
`byte` | `readByte()` Reads a byte from the `buffer`, and refills it as necessary.
`java.lang.String` | `readHeaders()` Reads the `header-part` of the current `encapsulation`.
`void` | `setBoundary(byte[] boundary)` Changes the boundary token used for partitioning the stream.
`void` | `setHeaderEncoding(java.lang.String encoding)` Specifies the character encoding to be used when reading the headers of individual parts.
`boolean` | `skipPreamble()` Finds the beginning of the first `encapsulation`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CR

    public static final byte CR

  The Carriage Return ASCII character value.

  See Also:
    Constant Field Values

### LF

    public static final byte LF

  The Line Feed ASCII character value.

  See Also:
    Constant Field Values

### DASH

    public static final byte DASH

  The dash (-) ASCII character value.

  See Also:
    Constant Field Values

### HEADER_PART_SIZE_MAX

    public static final int HEADER_PART_SIZE_MAX

  The maximum length of `header-part` that will be processed (10 kilobytes = 10240 bytes.).

  See Also:
    Constant Field Values

### DEFAULT_BUFSIZE

    protected static final int DEFAULT_BUFSIZE

  The default length of the buffer used for processing a request.

  See Also:
    Constant Field Values

### HEADER_SEPARATOR

    protected static final byte[] HEADER_SEPARATOR

  A byte sequence that marks the end of `header-part` (`CRLFCRLF`).

### FIELD_SEPARATOR

    protected static final byte[] FIELD_SEPARATOR

  A byte sequence that that follows a delimiter that will be followed by an encapsulation (`CRLF`).

### STREAM_TERMINATOR

    protected static final byte[] STREAM_TERMINATOR

  A byte sequence that that follows a delimiter of the last encapsulation in the stream (`--`).

### BOUNDARY_PREFIX

    protected static final byte[] BOUNDARY_PREFIX

  A byte sequence that precedes a boundary (`CRLF--`).

Constructor Detail

### MultipartStream

    public MultipartStream()

  Deprecated. Use `MultipartStream(InputStream, byte[], org.apache.commons.fileupload.MultipartStream.ProgressNotifier)`, or `MultipartStream(InputStream, byte[], int, org.apache.commons.fileupload.MultipartStream.ProgressNotifier)`

  Creates a new instance.

### MultipartStream

    public MultipartStream(java.io.InputStream input,
                           byte[] boundary,
                           int bufSize)

  Deprecated. Use `MultipartStream(InputStream, byte[], int, org.apache.commons.fileupload.MultipartStream.ProgressNotifier)`.

  Constructs a `MultipartStream` with a custom size buffer and no progress notifier.

  Note that the buffer must be at least big enough to contain the boundary string, plus 4 characters for CR/LF and double dash, plus at least one byte of data. Too small a buffer size setting will degrade performance.

  Parameters:
    `input` - The `InputStream` to serve as a data source.
    `boundary` - The token used for dividing the stream into `encapsulations`.
    `bufSize` - The size of the buffer to be used, in bytes.
  See Also:
    `MultipartStream(InputStream, byte[], MultipartStream.ProgressNotifier)`

### MultipartStream

    public MultipartStream(java.io.InputStream input,
                           byte[] boundary)

  Deprecated. Use `MultipartStream(InputStream, byte[], MultipartStream.ProgressNotifier)`.

  Constructs a `MultipartStream` with a default size buffer.

  Parameters:
    `input` - The `InputStream` to serve as a data source.
    `boundary` - The token used for dividing the stream into `encapsulations`.
  See Also:
    `MultipartStream(InputStream, byte[], int, MultipartStream.ProgressNotifier)`

Method Detail

### getHeaderEncoding

    public java.lang.String getHeaderEncoding()

  Retrieves the character encoding used when reading the headers of an individual part. When not specified, or `null`, the platform default encoding is used.

  Returns:
    The encoding used to read part headers.

### setHeaderEncoding

    public void setHeaderEncoding(java.lang.String encoding)

  Specifies the character encoding to be used when reading the headers of individual parts. When not specified, or `null`, the platform default encoding is used.

  Parameters:
    `encoding` - The encoding used to read part headers.

### readByte

    public byte readByte()
                  throws java.io.IOException

  Reads a byte from the `buffer`, and refills it as necessary.

  Returns:
    The next byte from the input stream.
  Throws:
    `java.io.IOException` - if there is no more data available.

### readBoundary

    public boolean readBoundary()
                         throws MultipartStream.MalformedStreamException

  Skips a `boundary` token, and checks whether more `encapsulations` are contained in the stream.

  Returns:
    `true` if there are more encapsulations in this stream; `false` otherwise.
  Throws:
    `MultipartStream.MalformedStreamException` - if the stream ends unexpecetedly or fails to follow required syntax.

### setBoundary

    public void setBoundary(byte[] boundary)
                     throws MultipartStream.IllegalBoundaryException

  Changes the boundary token used for partitioning the stream.

  This method allows single pass processing of nested multipart streams.

  The boundary token of the nested stream is `required` to be of the same length as the boundary token in parent stream.

  Restoring the parent stream boundary token after processing of a nested stream is left to the application.

  Parameters:
    `boundary` - The boundary to be used for parsing of the nested stream.
  Throws:
    `MultipartStream.IllegalBoundaryException` - if the `boundary` has a different length than the one being currently parsed.

### readHeaders

    public java.lang.String readHeaders()
                                 throws MultipartStream.MalformedStreamException

  Reads the `header-part` of the current `encapsulation`.

  Headers are returned verbatim to the input stream, including the trailing `CRLF` marker. Parsing is left to the application.

  TODO allow limiting maximum header size to protect against abuse.

  Returns:
    The `header-part` of the current encapsulation.
  Throws:
    `MultipartStream.MalformedStreamException` - if the stream ends unexpecetedly.

### readBodyData

    public int readBodyData(java.io.OutputStream output)
                     throws MultipartStream.MalformedStreamException,
                            java.io.IOException

  Reads `body-data` from the current `encapsulation` and writes its contents into the output `Stream`.

  Arbitrary large amounts of data can be processed by this method using a constant size buffer. (see `constructor`).

  Parameters:
    `output` - The `Stream` to write data into. May be null, in which case this method is equivalent to `discardBodyData()`.
  Returns:
    the amount of data written.
  Throws:
    `MultipartStream.MalformedStreamException` - if the stream ends unexpectedly.
    `java.io.IOException` - if an i/o error occurs.

### discardBodyData

    public int discardBodyData()
                        throws MultipartStream.MalformedStreamException,
                               java.io.IOException

  Reads `body-data` from the current `encapsulation` and discards it.

  Use this method to skip encapsulations you don't need or don't understand.

  Returns:
    The amount of data discarded.
  Throws:
    `MultipartStream.MalformedStreamException` - if the stream ends unexpectedly.
    `java.io.IOException` - if an i/o error occurs.

### skipPreamble

    public boolean skipPreamble()
                         throws java.io.IOException

  Finds the beginning of the first `encapsulation`.

  Returns:
    `true` if an `encapsulation` was found in the stream.
  Throws:
    `java.io.IOException` - if an i/o error occurs.

### arrayequals

    public static boolean arrayequals(byte[] a,
                                      byte[] b,
                                      int count)

  Compares `count` first bytes in the arrays `a` and `b`.

  Parameters:
    `a` - The first array to compare.
    `b` - The second array to compare.
    `count` - How many bytes should be compared.
  Returns:
    `true` if `count` first bytes in arrays `a` and `b` are equal.

### findByte

    protected int findByte(byte value,
                           int pos)

  Searches for a byte of specified value in the `buffer`, starting at the specified `position`.

  Parameters:
    `value` - The value to find.
    `pos` - The starting position for searching.
  Returns:
    The position of byte found, counting from beginning of the `buffer`, or `-1` if not found.

### findSeparator

    protected int findSeparator()

  Searches for the `boundary` in the `buffer` region delimited by `head` and `tail`.

  Returns:
    The position of the boundary found, counting from the beginning of the `buffer`, or `-1` if not found.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ? 2002-2008 The Apache Software Foundation. All Rights Reserved.